#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include<set>

using namespace std;

bool check(vector<vector<char>>& field){
    vector<int> s(4, 0);
    int three = 0;
    int four = 0;
    for (int i = 0; i < 10; i++){
        for (int j = 0; j < 10; j++){
            if (field[i][j] == '#'){
                int counter = 0;
                bool up = false;
                bool right = false;
                if (i > 0){
                    if (field[i - 1][j] == '#'){
                        up = true;
                    }
                }
                if (j > 0){
                    if (field[i][j - 1] == '#'){
                        right = true;
                    }
                }
                if (i < 9){
                    if (field[i + 1][j] == '#'){
                        up = true;
                    }
                }
                if (j < 9){
                    if (field[i][j + 1] == '#'){
                        right = true;
                    }
                }
                if (right && up){
                    return false;
                }
                if (i > 0 && j > 0){
                    if (field[i - 1][j - 1] == '#'){
                        return false;
                    }
                }
                if (i > 0 && j < 9){
                     if (field[i - 1][j + 1] == '#'){
                        return false;
                    }
                }
                if (i < 9 && j > 0){
                     if (field[i + 1][j - 1] == '#'){
                        return false;
                    }
                }
                if (i < 9 && j < 9){
                     if (field[i + 1][j + 1] == '#'){
                        return false;
                    }
                }
            }
        }
    }
    set<pair<int, int>> positions;
    for (int i = 0; i < 10; i++){
        for (int j = 0; j < 10; j++){
            if (field[i][j] == '#' && find(positions.begin(), positions.end(), make_pair(i, j)) == positions.end()){
                int dir = -1;
                if (i > 0){
                    if (field[i - 1][j] == '#'){
                        dir = 0;
                    }
                }
                if (j > 0){
                    if (field[i][j - 1] == '#'){
                        dir = 3;
                    }
                }
                if (i < 9){
                    if (field[i + 1][j] == '#'){
                        dir = 2;
                    }
                }
                if (j < 9){
                    if (field[i][j + 1] == '#'){
                        dir = 1;
                    }
                }
                int ci = i;
                int cj = j;
                int length = 0;
                //cout << dir << endl;
                //cout << ci << " " << cj << " " << " " << field[ci][cj] << endl;
                while (ci >= 0 && cj >= 0 && ci < 10 && cj < 10 && field[ci][cj] == '#'){
                    positions.insert(make_pair(ci, cj));
                    length++;
                    if (dir == 0){
                        ci--;
                    }
                    if (dir == 1){
                        cj++;
                    }
                    if (dir == 2){
                        ci++;
                    }
                    if (dir == 3){
                        cj--;
                    }
                    if (dir == -1){
                        break;
                    }
                }
                if (length > 4){
                    return false;
                }
                s[length - 1]++;
            }
        }
    }
    
    if (s[0] != 4 || s[1] != 3 || s[2] != 2 || s[3] != 1){
        return false;
    }
    return true;
}

int main() {
   vector<vector<char>> field(10, vector<char>(10, ' '));
   for (int i = 0; i < 10; i++){
        for (int j = 0; j < 10; j++){
            cin >> field[i][j];
        }
   }
   bool ans = check(field);
   if (ans){
    cout << "YES";
   }
   else{
    cout << "NO";
   }

}


