#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

int dx[8] = {0, 0, 1, -1, 1, 1, -1, -1};
int dy[8] = {-1, 1, 0, 0, 1, -1, 1, -1};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    vector<vector<char>> f(10, vector<char>(10));
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            cin >> f[i][j];
        }
    }

    int c = 0;

    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (f[i][j] == '.') continue;
            c++;

            for (int k = 4; k < 8; k++) {
                int x = i + dx[k];
                int y = j + dx[k];
                if (x < 0 || x > 9 || y < 0 || y > 9) continue;

                if (f[x][y] == '#') {
                    cout << "NO\n";
                    return 0;
                }
            }
        }
    }

    if (c != 4 + 2 * 3 + 3 * 2 + 4) {
        cout << "NO\n";
        return 0;
    }

    map<int, int> cnt;

    vector<vector<int>> used(10, vector<int>(10, 0));
    auto bfs = [&](int x, int y) {
        if (used[x][y]) return;

        int sz = 0;
        deque<pair<int, int>> q;
        q.push_back({x, y});
        used[x][y] = 1;
        while (!q.empty()) {
            auto [cur_x, cur_y] = q.front();
            q.pop_front();
            sz++;

            for (int k = 0; k < 4; k++) {
                int nx = cur_x + dx[k];
                int ny = cur_y + dy[k];
                if (nx < 0 || nx > 9 || ny < 0 || ny > 9) continue;

                if (f[nx][ny] == '#' && !used[nx][ny]) {
                    used[nx][ny] = 1;
                    q.push_back({nx, ny});
                }
            }
        }

        cnt[sz]++;
    };

    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (f[i][j] == '#') {
                bfs(i, j);
            }
        }
    }

    if (cnt[1] == 4 && cnt[2] == 3 && cnt[3] == 2 && cnt[4] == 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }

    return 0;
}