#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> s1(m), s2(k);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        if (a > b) swap(a, b);
        s1[i] = {a, b};
    }
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        if (a > b) swap(a, b);
        s2[i] = {a, b};
    }

    sort(all(s1));
    sort(all(s2));

    vector<set<int>> g(n);
    for (int i = 0; i < m; i++) {
        int pos = lower_bound(all(s2), s1[i]) - s2.begin();
        if (pos != s2.size() && s2[pos] == s1[i]) continue;
        g[s1[i].first].insert(s1[i].second);
        g[s1[i].second].insert(s1[i].first);
    }
    for (int i = 0; i < k; i++) {
        int pos = lower_bound(all(s1), s2[i]) - s1.begin();
        if (pos != s1.size() && s1[pos] == s2[i]) continue;
        g[s2[i].first].insert(s2[i].second);
        g[s2[i].second].insert(s2[i].first);
    }

    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.emplace(g[i].size(), i);
    }

    vector<vector<int>> ans;
    while (prev(s.end())->first >= 2) {
        int v = prev(s.end())->second;
        int a = *g[v].begin(), b = *next(g[v].begin());
        ans.push_back({v, a, b});

        s.erase(make_pair(g[v].size(), v));
        s.erase(make_pair(g[a].size(), a));
        s.erase(make_pair(g[b].size(), b));

        g[v].erase(a);
        g[v].erase(b);
        g[a].erase(v);
        g[b].erase(v);
        if (g[a].find(b) == g[a].end()) {
            g[a].insert(b);
            g[b].insert(a);
        } else {
            g[a].erase(b);
            g[b].erase(a);
        }

        s.insert(make_pair(g[v].size(), v));
        s.insert(make_pair(g[a].size(), a));
        s.insert(make_pair(g[b].size(), b));
    }

    if (prev(s.end())->first != 0) {
        cout << "NO";
    } else {
        cout << "YES\n";
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); i++) {
            sort(all(ans[i]));
            cout << ans[i][0] + 1 << " " << ans[i][1] + 1 << " " << ans[i][2] + 1 << "\n";
        }
    }

}