#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include<sstream>

using namespace __gnu_pbds;
using namespace std;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define maxI 2147483647
#define minI -2147483648
#define maxLL 9223372036854775807
#define minLL -9223372036854775808

mt19937 gen;

int ran(int n) {
    return uniform_int_distribution<int>(0, n - 1)(gen);
}

typedef long long ll;
typedef long double ld;

struct sprs {
    vector<vector<pair<ll, ll>>> st;

    void init(int n, vector<pair<ll, ll>> &arr) {
        st.resize(__lg(n) + 3, vector<pair<ll, ll>>(n, {0, 0}));
        st[0] = arr;
        for (int lvl = 1; lvl <= __lg(n) + 1; ++lvl) {
            for (int l = 0; l + (1 << lvl) - 1 <= n; ++l) {
                st[lvl][l] = max(st[lvl - 1][l], st[lvl - 1][l + (1 << (lvl - 1))]);
            }
        }
    };

    pair<ll, ll> f(int l, int r) {
        r++;
        int k = __lg(r - l);
        pair<ll, ll> t = max(st[k][l], st[k][r - (1 << k)]);
        return t;
    }
};

ld pow2(ld a, ll b) {
    if (b == 1) {
        return a;
    }
    if (b == 0) {
        return 1;
    }
    ld x = pow2(a, b / 2);
    x *= x;
    if (b % 2 == 0) {
        return x;
    } else {
        return x * a;
    }
}

void sort(vector<int> &arr) {
    sort(arr.begin(), arr.end());
}

void no() {
    cout << "-1";
    exit(0);
}

vector<int> ans;

void reCursion(int l, int r, int lx, int rx, vector<vector<int>> &vec, int lvl, int vecind) {
    if (lvl < 0)
        return;
    int m = l + r;
    m /= 2;
    if (vec[lvl][vecind] < lx || vec[lvl][vecind + 1] < rx)
        no();
    ans[m] = vec[lvl][vecind];
    ans[m + 1] = vec[lvl][vecind + 1];
    reCursion(l, m, lx, vec[lvl][vecind], vec, lvl - 1, vecind * 2);
    reCursion(m + 1, r, vec[lvl][vecind], rx, vec, lvl - 1, vecind * 2 + 2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> arr(n);
    map<int, int> m;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        m[arr[i]]++;
    }
    if (n == 1) {
        cout << arr[0];
        return 0;
    }
    int n1 = n + 1;
    n1 /= 2;
    ans.resize(n1);
    int hate = __lg(n1);
    hate++;
    if (m.size() != n1) {
        cout << "-1";
        return 0;
    }
    vector<vector<int>> vec(hate);
    for (pair<int, int> i: m) {
        if (i.second > hate) {
            cout << "-1";
            exit(0);
        }
        vec[i.second - 1].push_back(i.first);
    }

    for (int i = 0; i < hate; ++i) {
        sort(vec[i]);
    }
    int pw = 1;
    if (vec[hate - 1].size() != 1) {
        cout << "-1";
        return 0;
    }
    for (int i = 1; i < hate; ++i) {
        if (vec[hate - i - 1].size() != pw) {
            no();
        }
        pw += pw;
    }
    if (vec[hate - 2][0] < vec[hate - 1][0])
        no();
    ans[0] = vec[hate - 1][0];
    ans[n1 - 1] = vec[hate - 2][0];
    reCursion(0, n1 - 1, vec[hate - 1][0], vec[hate - 2][0], vec, hate - 3, 0);
    for (int i: ans)
        cout << i << " ";
    return 0;
}
