#include <bits/stdc++.h>

using namespace std;

/*#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;*/

#define ll long long
#define ld long double
#define all(a) (a).begin(), (a).end()
#define endl '\n'
#define fast ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct segtree{
    int n;
    vector <int> tree;
    vector <int> input;

    void build(int i, int l, int r) {
        if(l == r) {
            tree[i] = input[l];
            return;
        }

        int mid = (l + r) / 2;

        build(i * 2, l, mid);
        build(i * 2 + 1, mid + 1, r);
        tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
    }

    segtree(vector <int> a) {
        n = a.size();
        input = a;
        tree.resize(2 * n);
        build(1, 0, n - 1);
    }

    vector <int> print() {
        vector <int> b;
        for(int i = 1; i <= 2 * n - 1; ++i) {
            b.push_back(tree[i]);
        }
        return b;
    }
};

int main() {
    fast;

    int n;
    cin >> n;
    vector <int> b(n);
    map <int, int> m;

    set <int> d;
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        d.insert(b[i]);
    }
    int k = __lg(n + 1);
    int sz = n + 1;
    sort(all(b));
    vector <int> a(n);

    map <int, int> uni;
    map <int, int> obr;

    int cnt1 = 1;
    for (int i : d) {
        uni[i] = cnt1;
        obr[cnt1] = i;
        cnt1++;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = uni[b[i]];
    }
    for (int i = 0; i < n; ++i) {
        m[a[i]]++;
    }
    if (n == 1) {
        cout << a[0];
        return 0;
    }
    int maxx = m.rbegin()->first;
    map <int, int> cnt;
    for (auto [k, v] : m) {
        cnt[v]++;
    }

    vector <int> cnt2;
    for (auto [i, v] : cnt) {
        cnt2.push_back(v);
    }

    sort(all(cnt2));

    if (cnt2[0] == 1 && cnt2[1] == 1) {
        for (int i = 2; i < (int) cnt2.size(); ++i) {
            if (cnt2[i] != cnt2[i-1] * 2) {
                cout << -1;
                return 0;
            }
        }
    } else {
        cout << -1;
        return 0;
    }


    set <int> ans;
    for (int i = 1; i <= k; ++i) {
        set <int> tec;
        vector <int> del;
        for (auto [el, c] : m) {
            if (c == i) {
                del.push_back(el);
            }
            if (c >= i) {
                tec.insert(el);
            }
        }
        for (int h : del) {
            m.erase(h);
        }
        if (i > 1) {
            int z = (int) tec.size() * 2;
            int N = 0;
            int t = 0;
            for (int j = z; j > 0; --j) {
                N++;
                if (tec.find(j) != tec.end()) {
                    t++;
                }
                if (t > N / 2) {
                    cout << -1;
                    return 0;
                }
            }
        }
        if (i == 2) {
            ans = tec;
        }
    }
    vector <int> ans_;
    for (int i : ans) {
        ans_.push_back(i);
    }
    vector <int> ans2;
    set <int> s;
    for (int i = 1; i <= maxx; ++i) {
        s.insert(i);
    }
    for (int i = (int) ans_.size() - 1; i >= 0;--i) {
        ans2.push_back(*s.rbegin());
        s.erase(*s.rbegin());
        ans2.push_back(ans_[i]);
        s.erase(ans_[i]);
    }

    for (int i = 0; i < (int) ans2.size(); ++i) {
        ans2[i] = obr[ans2[i]];
    }

    segtree DO(ans2);

    vector <int> ans23 = DO.print();
    sort(all(ans23));

    if (b == ans23) {
        for  (int i : ans2) {
            cout << i << ' ';
        }
    } else {
        cout << -1;
    }


    return 0;

}