#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define _ <<" "<<
#define pb push_back
#define eb emplace_back
#define ll long long
#define ld long double
#define ull unsigned long long

void solve() {
    vector<vector<int>> a(10, vector<int>(10));
    auto used = a;

    forn(i, 10) {
        forn(j, 10) {
            char c;
            cin >> c;
            a[i][j] = (c == '#');
        }
    }


    vector<int> cnt(4);
    forn(i, 10) {
        forn(j, 10) {
            if (!a[i][j]) continue;
            if (!used[i][j]) {
                int mn_x, mx_x, mn_y, mx_y, cur = 0;
                mn_x = mx_x = i;
                mn_y = mx_y = j;
                function<void(int, int)> dfs = [&](int X, int Y) {
                    used[X][Y] = 1, cur++;
                    mn_x = min(mn_x, X);
                    mx_x = max(mx_x, X);
                    mn_y = min(mn_y, Y);
                    mx_y = max(mx_y, Y);
                    for (int d1 = -1; d1 <= 1; d1++) {
                        for (int d2 = -1; d2 <= 1; d2++) {
                            if (!d1 && !d2) continue;
                            int nx = X + d1, ny = Y + d2;
                            if (nx >= 0 && nx < 10 && ny >= 0 && ny < 10 && !used[nx][ny] && a[nx][ny]) dfs(nx, ny);
                        }
                    }
                };
                dfs(i, j);
                if (mn_x != mx_x && mn_y != mx_y) {
                    cout << "NO" << nl;
                    return;
                }
                cnt[cur - 1]++;
            }
        }
    }
    if (cnt == vector<int>{4, 3, 2, 1}) {
        cout << "YES" << nl;
    } else {
        cout << "NO" << nl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}