#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define _ <<" "<<
#define pb push_back
#define eb emplace_back
#define ll long long
#define ld long double
#define ull unsigned long long

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    set<pair<int, int>> edges;
    vector<int> cnt(n);
    forn(i, m) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        cnt[a]++, cnt[b]++;
        if (a > b) swap(a, b);
        edges.emplace(a, b);
    }
    forn(i, k) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        cnt[a]--, cnt[b]--;
        if (a > b) swap(a, b);
        if (edges.find({a, b}) != edges.end()) edges.extract({a, b});
        else edges.emplace(a, b);
    }
    forn(i, n) {
        if (cnt[i] & 1) {
            cout << "NO" << nl;
            return;
        }
    }

    vector<array<int, 3>> ans;
    while (!edges.empty()) {
        auto [a, b] = *edges.begin();
        edges.erase(edges.begin());
        auto [c, d] = *edges.begin();
        edges.erase(edges.begin());
        ans.emplace_back(array<int, 3>{a, b, d});
        if (b > d) swap(b, d);
        if (edges.find({b, d}) != edges.end()) edges.extract({b, d});
        else edges.emplace(b, d);
    }
    cout << "YES" << nl << ans.size() << nl;
    for (auto &[a, b, c]: ans) cout << a + 1 _ b + 1 _ c + 1 << nl;


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}