#include<iostream>
#include<algorithm>
#include<set>
#include<string>
#include<vector>
#include<cmath>
using namespace std;

char a[10][10] = {};
int check_point(int i, int j)
{
    if(i < 0 || j < 0)
        return 0;
    if(i >= 10 || j >= 10)
        return 0;
    if(a[i][j] == '#')
        return 1;
    return -1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    for(int i = 0; i < 10; i++)
    {
        for(int j = 0; j < 10; j++)
            cin >> a[i][j];
    }

    int cnt[5] = {};
    for(int i = 0; i < 10; i++)
    {
        for(int j = 0; j < 10; j++)
        {
            if(check_point(i, j) != 1)
                continue;
            if(check_point(i - 1, j) == 1)
                continue;
            if(check_point(i, j - 1) == 1)
                continue;

            int vi = 0, vj = 0;
            int len = 0;
            if(check_point(i + 1, j) == 1)
                vi = 1;
            else if(check_point(i, j + 1) == 1)
                vj = 1;
            else
            {
                bool ans = true;
                if(check_point(i - 1, j - 1) == 1)
                    ans = false;
                if(check_point(i - 1, j) == 1)
                    ans = false;
                if(check_point(i - 1, j + 1) == 1)
                    ans = false;
                if(check_point(i, j - 1) == 1)
                    ans = false;
                if(check_point(i, j + 1) == 1)
                    ans = false;
                if(check_point(i + 1, j - 1) == 1)
                    ans = false;
                if(check_point(i + 1, j) == 1)
                    ans = false;
                if(check_point(i + 1, j + 1) == 1)
                    ans = false;
                if(!ans)
                {
                    return 0;
                }
                cnt[1]++;
                continue;
            }
            bool ans = true;
            int pi = i, pj = j;

            while (check_point(pi, pj) == 1) {
                len++;
                pi += vi;
                pj += vj;
            }
            if(len > 4)
                ans = false;

            if(len <= 4)
                cnt[len]++;

            pi = i; pj = j;
            for(int k = 0; k < len; k++)
            {
                if(check_point(pi + vj, pj + vi) == 1) {
                    ans = false;
                }
                if(check_point(pi - vj, pj - vi) == 1) {
                    ans = false;
                }

                if(k == 0 || k == len - 1)
                {
                    int bi = pi, bj = pj;
                    if(k == 0)
                    {
                        bi = pi - vi;
                        bj = pj - vj;
                    }
                    else
                    {
                        bi = pi + vi;
                        bj = pj + vj;
                    }

                    if(check_point(bi, bj) == 1) {
                        ans = false;
                    }
                    if(check_point(bi + vj, bj + vi) == 1) {
                        ans = false;
                    }
                    if(check_point(bi - vj, bj - vi) == 1) {
                        ans = false;
                    }
                }

                pi += vi;
                pj += vj;
            }

            if(!ans)
            {
                cout << "NO";
                return 0;
            }
        }
    }

    for(int i = 1; i <= 4; i++)
    {
        if(cnt[i] != 5 - i)
        {
            cout << "NO";
            return 0;
        }
    }

    cout << "YES";
}