#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

int mod(int x, int m) {
    return (x % m + m) % m;
}

int gcd_ext(int a, int b, int &x, int &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    int x1, y1;
    int d = gcd_ext(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

void diof() {
    int a, m, x, y;
    cin >> a >> m;
    if (__gcd(a, m) != 1) cout << -1;
    else {
        gcd_ext(a, m, x, y);
        cout << mod(x, m);
    }
}

void lin_sieve() {
    int n = 1e8;
    vector<int> lp(n + 1);
    vector<int> pr;
    for (int i = 2; i <= n; i++) {
        if (lp[i] == 0) {
            lp[i] = i;
            pr.push_back(i);
        }
        for (int j = 0; j < pr.size() && pr[j] <= lp[i] && i * pr[j] <= n; j++)
            lp[i * pr[j]] = pr[j];
    }
    for (int i = 0;i < 100;i ++){
        cout << i << " " << lp[i] << endl;
    }
}

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    ll a = n / k;
    if (n % k > 0) {
        ++a;
    }
    ll b = m / k;
    if (m % k > 0) {
        ++b;
    }
    cout << a * b;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
