#include <bits/stdc++.h>

using namespace std;

const int n = 10, m = 10;

vector < vector <char>> t;
vector < vector <bool>> used;
int pr = 0;

bool check (int i, int j) {
    if (i >= 0 && i < n && j >= 0 && j < m)
        return true;

    return false;
}

bool dfs (int i, int j) {
    used[i][j] = true;

    vector <int> f_i{0, 0, +1, -1};
    vector <int> f_j{+1, -1, 0, 0};

    for (int id = 0; id < 4; ++id) {
        int n_i = i + f_i[id], n_j = j + f_j[id];

        if (check(n_i, n_j) && t[n_i][n_j] == '#' && !used[n_i][n_j] && !dfs(n_i, n_j))
            return false;
    }

    f_i = {+1, +1, -1, +1};
    f_j = {+1, -1, +1, -1};

    for (int id = 0; id < 4; ++id) {
        int n_i = i + f_i[id], n_j = j + f_j[id];

        if (check(n_i, n_j) && t[n_i][n_j] == '#')
            return false;
    }

    return true;
}

int main() {
    used.resize(n, vector<bool>(m, false));
    t.resize(n, vector <char>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> t[i][j];
        }
    }



    vector <int> cnt(101, 0);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (t[i][j] == '#' && !used[i][j]) {
                if (!dfs(i, j)) {
                    cout << "NO\n";
                    return 0;
                }

                int k = 0;

                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        if (used[i][j])
                            ++k;
                    }
                }

                int add = k - pr;
                pr = k;

                if (add > 0)
                    ++cnt[add];
            }
        }
    }

    vector <int> check_cnt(101, 0);
    check_cnt[1] = 4;
    check_cnt[2] = 3;
    check_cnt[3] = 2;
    check_cnt[4] = 1;

    if (cnt == check_cnt)
        cout << "YES\n";
    else
        cout << "NO\n";
}
