#include <iostream>
#include<string>
#include<vector>
#include <algorithm>
using namespace std;
long double pow(long double r,int e){
    if(e<0)cout<<e;
    if(e==0)return 1;
    if(e==1)return r;
    if(e%2)return r * pow(r,e-1);

    long double a = pow(r,e/2);
    return a*a;

}

int bin_search(vector<pair<int,int>>& d,int x){
    int l = 0, r = d.size()-1;
    int m;
    while(l!=r){
        m = (l+r)/2;
        if(d[m].first<x)l = m+1;
        else r = m;

    }
    if(x<d[l].first&&l>0)l--;
    return l;
}

int main(){
   int n, m;
   cin>>n>>m;
   vector<pair<int,int>> d(n);

   long double r;
   cin>>r;
   vector<int> ins(m);

   for(int i = 0;i<n;i++){
       cin>>d[i].first>>d[i].second;

   }
   sort(d.begin(),d.end());
   for(int i = 0;i<m;i++)cin>>ins[i];

   vector<long double>pre_count(n);
   pre_count[0] = r*d[0].second;
   for(int i = 1;i<n;i++){
       pre_count[i] = pow(1-r,d[i].first - d[i-1].first)*pre_count[i-1] + r*d[i].second;

   }
   for(int i = 0;i<m;i++){

      if(d[0].first>ins[i]){
          cout<<0<<' ';

      } else {
          int ind = bin_search(d,ins[i]);
          long double a =pre_count[ind]*pow(1-r,ins[i] -d[ind].first);
          cout.precision(8);

          cout << a <<' ';


      }

   }




}



/*

#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
..........
####...#..
.......#..
.......#..
##........

 */

/*
 bool used[10][10]{};
int  check(const vector<string>& table,int i, int j){
      if(used[i][j])return 0;
       bool hor = 0, ver = 0;
       used[i][j] = 1;

           if(i-1>=0&&j<=9&&j>=0)
                if(table[i-1][j]=='#') hor = 1;
           if(i-1<=9)
            if(table[i+1][j]=='#')hor = 1;

           if(j>0&&table[i][j-1]=='#'||j<9&&table[i][j+1]=='#')ver = 1;
           if(hor&&ver)return -1;
            int k1 = 0,k2 = 0;
            if(i<9&&table[i+1][j]=='#' )k1 = check(table,i+1,j);
            else if (j<9&&table[i][j+1]=='#')k1 = check(table,i,j+1);

            if(i>0&&table[i-1][j]=='#')k2 = check(table,i-1,j);
            else if (j>0&&table[i][j-1]=='#')k2 = check(table,i,j-1);

            if(k1==-1||k2==-1)return-1;
            return 1 + k1 + k2;



}

int main() {

   vector<string> table (13);
   string s;
    for(int i = 0;i<10;i++){
        cin>>s;
        table[i] = s;
      //  cout<<i<<endl;
    }
    cout<<"hhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh";
    int arr[5]{};
    for( int i = 0;i<10;i++){
        for(int j = 0;j<10;j++){
            if(table[i][j]=='#'&&used[i][j]==0){
                int b = check(table,i,j);
                if(b<0||b>4){
                    cout<<"NO";
                    return 0;

                }
                //cout<<"||"<<b<<endl;
                arr[b]++;
            }

        }
    }
    if(arr[1]==4&&arr[2]==3&&arr[3]==2&&arr[4]==1)cout<<"YES\n";
     cout<<arr[1]<<endl<<arr[2]<<endl<<arr[3]<<endl<<arr[4];

    return 0;
}
 */