#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> costs;
    for (int i = 0; i < m; ++i) {
        int element;
        cin >> element;
        costs.push_back(element);
    }

    sort(costs.begin(), costs.end());

    set<int> variants;
    for (int i = 0; i < m; ++i) {
        int nextPosition = i + n - 1;
        if (nextPosition >= m) break;

        if (costs.at(i) == costs.at(nextPosition)) {
            variants.insert(costs.at(i));
        }
    }

    cout << variants.size() << endl;
    for (int a: variants) {
        cout << a << " ";
    }

    return 0;
}
