#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll inf = 1e18;
const ll mod = 1e9 + 7;

int n;

vector<ll> h;
vector<ll> c;
vector<ll> max2;
vector<vector<ll>> minn;


map<ll, int> indexs;

void count() {
    max2[0] = 0;
    max2[1] = 0;
    for (int i = 2; i <= n; ++i) {
        max2[i] = max2[i / 2] + 1;
    }
}

void build(vector<ll> &a) {
    for (int i = 0; i < n; ++i) {
        minn[0][i] = a[i];
    }
    for (int i = 1; i <= max2[n]; ++i) {
        for (int j = 0; j < (n - (1 << (i)) + 1); ++j) {
            minn[i][j] = max(minn[i - 1][j], minn[i - 1][j + (1 << (i - 1))]);
        }
    }
}

ll rmq(ll l, ll r) {
    ll k = max2[r - l];
    return max(minn[k][l], minn[k][r - (1 << k) + 1]);
}

ll proc(int l, int r) {
    if (r-l < 0) {
        return 0;
    }
    int index = indexs[rmq(l, r)];
    return c[index]+min(proc(l, index-1), proc(index+1, r));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    max2.resize(n + 1);
    count();

    h.resize(n);
    c.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        indexs[h[i]] = i;
    }
    for (int i=0; i<n; ++i) {
        cin >> c[i];
    }

    minn.resize(max2[n] + 1, vector<ll>(n));
    build(h);

    cout << proc(0, n-1) << '\n';
}
