import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.stream.IntStream;

public class Main {

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
        String line = reader.readLine();
        String[] split = line.split(" ");
        int n = Integer.parseInt(split[0]), m = Integer.parseInt(split[1]);
        double r = Double.parseDouble(reader.readLine());
        int[] d = new int[n], w = new int[n];
        for (int i = 0; i < n; i++) {
            line = reader.readLine();
            split = line.split(" ");
            d[i] = Integer.parseInt(split[0]);
            w[i] = Integer.parseInt(split[1]);
        }
        int[] q = new int[m];
        String[] s = reader.readLine().split(" ");
        for (int i = 0; i < m; i++) q[i] = Integer.parseInt(s[i]);
        int[] ind = IntStream.range(0, n).boxed().sorted(Comparator.comparingInt(i -> d[i])).mapToInt(i -> i).toArray();
        double[] a = new double[n];
        a[0] = w[ind[0]] * r;
        for (int i = 1; i < n; i++) {
            int k = d[ind[i]] - d[ind[i - 1]];
            a[i] = Math.pow(1 - r, k) * a[i - 1] + w[ind[i]] * r;
        }
        Arrays.sort(d);
        for (int i = 0; i < m; i++) {
            int find = Arrays.binarySearch(d, q[i]);
            if (find >= 0) writer.write(a[find] + " ");
            else {
                find = -find - 2;
                if (find == -1) writer.write("0 ");
                else writer.write(a[find] * Math.pow(1 - r, q[i] - d[find]) + " ");
            }
        }
        writer.flush();
    }

}