#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

struct mst {

    mst() {}
    mst(vector<int> a) {
        n = a.size();
        v.resize(n * 4);
        build(a, 0, 0, n - 1);
    }

    void build(vector<int>& a, int pos, int l, int r) {
        if (l == r) {
            v[pos] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(a, pos * 2 + 1, l, m);
        build(a, pos * 2 + 2, m + 1, r);

        merge(all(v[pos * 2 + 1]), all(v[pos * 2 + 2]), back_inserter(v[pos]));
    }

    int less_equal(int l, int r, int x, int pos, int tl, int tr) {
        if (r < tl || tr < l) return 0;
        if (l <= tl && tr <= r) {
            return upper_bound(all(v[pos]), x) - v[pos].begin();
        }
        int m = (tl + tr) / 2;
        return less_equal(l, r, x, pos * 2 + 1, tl, m) + less_equal(l, r, x, pos * 2 + 2, m + 1, tr);
    }

    int n;
    vector<vector<int>> v;

};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, q, k;
    cin >> n >> q >> k;
    k--;

    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
    }

    vector<pair<int, int>> qr(q);
    for (int i = 0; i < q; i++) {
        cin >> qr[i].first >> qr[i].second;
        qr[i].first--, qr[i].second--;
    }

    mst ms(v);

    for (int i = q - 1; i >= 0; i--) {
        auto [l, r] = qr[i];
        if (k < l || r < k) continue;
        int t = ms.less_equal(0, r - l, v[k - l], 0, 0, n - 1);
        k = l + t - 1;
    }

    cout << k + 1;

}