#include <bits/stdc++.h>
using namespace std;

double eps = 1e-9;

struct tochka
{
    double x;
    double y;

    tochka operator+(tochka o) {
        tochka c;
        c.x = x + o.x;
        c.y = y + o.y;
        return c;


    }

    tochka operator-(tochka o)
    {
        tochka c;
        c.x=x-o.x;
        c.y=y-o.y;
        return c;
    }

    double operator*(tochka o)
    {
        return x * o.x + y * o.y;
    }
    double operator%(tochka o)
    {
        return x * o.y - y * o.x;
    }
    tochka operator*(double k)
    {
        tochka c;
        c.x = x * k;
        c.y = y * k;
        return c;
    }



};
bool comp(tochka a,tochka b)
{
    if(a%b>=eps){return true;}
    if(a%b<=eps){return false;}
    return (a*a) < (b*b);
}
int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    if(n % k == 0)
    {
        n = n / k;
    } else {
        n = n / k;
        ++n;
    }
    if(m % k == 0)
    {
        m = m/k;
    } else {
        m = m/k;
        ++m;
    }
    cout << n * m << '\n';
}