#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

struct trp{
    int a, b, c;
    trp() {
        a = 0, b = 0, c = 0;
    }
    trp(int x, int y, int z) {
        a = x;
        b = y;
        c = z;
    }
};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<trp> ans;
    vector<set<int>> g(n);
    vector<int> sz(n);
    set<pair<int, int>> q;
    for (int i = 0; i < m + k; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (g[x].find(y) != g[x].end()) {
            g[x].erase(y);
            g[y].erase(x);
            sz[x]--;
            sz[y]--;
        } else {
            g[x].insert(y);
            g[y].insert(x);
            sz[x]++;
            sz[y]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        q.insert({sz[i], i});
    }
    while (true) {
        auto [l, i] = *q.begin();
        if (l == 1) {
            cout << "NO";
            return;
        }
        if (l == 0) {
            break;
        }
        q.erase(q.begin());
        sz[i] = l % 2;
        auto it = g[i].begin();
        for (int j = 0; j < l; j += 2) {
            auto p = *it;
            ++it;
            auto z = *it;
            ++it;
            ans.push_back(trp(i, p, z));
            --sz[p];
            --sz[z];
            g[p].erase(i);
            g[z].erase(i);
            if (g[p].find(z) != g[p].end()) {
                g[p].erase(z);
                g[z].erase(z);
                --sz[p];
                --sz[z];
                q.erase({sz[p] + 2, p});
                q.insert({sz[p], p});
                q.erase({sz[z] + 2, z});
                q.insert({sz[z], z});
            } else {
                ++sz[p];
                ++sz[z];
                g[p].insert(z);
                g[z].insert(p);
            }
            if (l % 2 == 0) {
                g[i].clear();
            } else {
                auto it2 = g[i].end();
                --it2;
                int y = *it2;
                g[i].clear();
                g[i].insert(y);
            }
        }
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].a + 1 << ' ' << ans[i].b + 1 << ' ' << ans[i].c + 1 << '\n';
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
