#include <bits/stdc++.h>

using namespace std;

#define ll unsigned long long

const ll inf = (ll)1e18 + 1;

int main() {
    ll n;
    cin >> n;

    vector <ll> h(n);

    for (ll i = 0; i < n; ++i)
        cin >> h[i];

    vector <ll> c(n);

    for (ll i = 0; i < n; ++i)
        cin >> c[i];

    vector <ll> dp_up(n + 2), dp_down(n+2);
    dp_up[0] = inf;
    dp_down[0] = inf;
    dp_up[1] = inf;
    dp_down[1] = inf;
    dp_up[2]= c[0];
    dp_down[2] = c[0];

    vector <ll> jump(n);
    jump[0] = -1;

    for (ll i = 1; i < n; ++i) {
        if (h[i - 1] < h[i])
            dp_down[i + 2] = dp_down[i + 1] - c[i - 1] + c[i];
        else
            dp_down[i + 2] = min(dp_up[i + 1], dp_down[i + 1]) + c[i];

        ll cur = i;

        while (cur >= 0 && h[cur] <= h[i])
            cur = jump[cur];

        jump[i] = cur;

        ll j = cur, id;

        if (j == -1)
            id = -1;
        else
            id = jump[i];

        dp_up[i + 2] = c[i] + min(min(dp_up[j + 1], dp_down[j + 1]), min(dp_up[id + 1], dp_down[id + 1]));
    }

    cout << min(dp_up[n + 1], dp_down[n + 1]) << "\n";
}
