#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll inf = 1e18;
const ll mod = 1e9 + 7;
vector<vector<bool>>visited(10, vector<bool>(10));
vector<vector<char>>field(10, vector<char>(10));
ll dfs(ll i, ll j) {
    visited[i][j] = true;
    if (field[i][j] == '.') {
        return 0;
    }
    if (i > 0) {
        if (!visited[i - 1][j] && field[i - 1][j] == '#') {
            if (j > 0 && field[i][j - 1] == '#') {
                cout << "NO";
                exit(0);
            }
            if (j < 9 && field[i][j + 1] == '#') {
                cout << "NO";
                exit(0);
            }
            if (i < 9 && !visited[i + 1][j] && field[i + 1][j] == '#') {
                return dfs(i + 1, j) + dfs(i - 1, j) + 1;
            }
            else {
                return dfs(i - 1, j) + 1;
            }
        }
    }
    if (i < 9) {
        if (!visited[i + 1][j] && field[i + 1][j] == '#') {
            if (j > 0 && field[i][j - 1] == '#') {
                cout << "NO";
                exit(0);
            }
            if (j < 9 && field[i][j + 1] == '#') {
                cout << "NO";
                exit(0);
            }
            return 1 + dfs(i + 1, j);
        }
    }
    if (j > 0) {
        if (!visited[i][j - 1] && field[i][j - 1] == '#') {
            if (j < 9 && !visited[i][j + 1] && field[i][j + 1] == '#') {
                return dfs(i, j + 1) + dfs(i, j - 1) + 1;
            }
            else {
                return dfs(i, j - 1) + 1;
            }
        }
    }
    if (j < 9) {
        if (!visited[i][j + 1] && (field[i][j + 1] == '#')) {
            return 1ll + dfs(i, j + 1);
        }
    }
    return 1;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for (ll i = 0; i < 10; ++i) {
        for (ll j = 0; j < 10; ++j) {
            cin >> field[i][j];
        }
    }
    ll cnt1 = 0, cnt2 = 0, cnt3 = 0, cnt4 = 0;
    for (ll i = 0; i < 10; ++i) {
        for (ll j = 0; j < 10; ++j) {
            if (field[i][j] == '#') {
                if (i > 0 && j > 0 && field[i - 1][j - 1] == '#') {
                    cout << "NO";
                    return 0;
                }
                if (i > 0 && j < 9 && field[i - 1][j + 1] == '#') {
                    cout << "NO";
                    return 0;
                }
                if (i < 9 && j > 0 && field[i + 1][j - 1] == '#') {
                    cout << "NO";
                    return 0;
                }
                if (i < 9 && j < 9 && field[i + 1][j + 1] == '#') {
                    cout << "NO";
                    return 0;
                }
            }
        }
    }
    for (ll i = 0; i < 10; ++i) {
        for (ll j = 0; j < 10; ++j) {
            if (!visited[i][j]) {
                ll ans = dfs(i, j);
                if (ans == 1) {
                    cnt1++;
                }
                else if (ans == 2) {
                    cnt2++;
                }
                else if (ans == 3) {
                    cnt3++;
                }
                else if (ans == 4) {
                    cnt4++;
                }
                else if (ans != 0) {
                    cout << "NO";
                    return 0;
                }
            }
        }
    }
    if (cnt1 == 4 && cnt2 == 3 && cnt3 == 2 && cnt4 == 1) {
        cout << "YES";
    }
    else {
        cout << "NO";
    }
}
