#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 42;
char field[MAX_N][MAX_N];
int cnt[MAX_N];
bool used[MAX_N][MAX_N];

bool check(int x, int y, int dx, int dy, int n, int m) {
    if (x + dx < 0 || x + dx >= n) {
        return false;
    }
    if (y + dy < 0 || y + dy >= m) {
        return false;
    }
    return true;
}

void dfs(int x, int y, int n, int m) {
    vector < int > dx = {0, 1, 0, -1};
    vector < int > dy = {1, 0, -1, 0};
    used[x][y] = 1;
    for (int k = 0; k < 4; k++) {
        if (check(x, y, dx[k], dy[k], n, m) && !used[x + dx[k]][y + dy[k]] && field[x + dx[k]][y + dy[k]] == '#') {
            dfs(x + dx[k], y + dy[k], n, m);
        }
    }
}


int main() {
    ios_base ::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n = 10, m = 10;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
        }
    }
    cnt[1] = 4;
    cnt[2] = 3;
    cnt[3] = 2;
    cnt[4] = 1;

    vector<int> dx = {-1, 1, 1, -1};
    vector<int> dy = {1, 1, -1, -1};

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') {
                continue;
            }
            for (int k = 0; k < 4; k++) {
                if (!check(i, j, dx[k], dy[k], n, m)) {
                    continue;
                }
                if (field[i + dx[k]][j + dy[k]] == '#') {
                    cout << "NO";
                    return 0;
                }
            }
        }
    }

    int comp = 0;
    int all = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '#') {
                all++;
                if (!used[i][j]) {
                    dfs(i, j, n, m);
                    comp++;
                }
            }
        }
    }
    if (all == 20 && comp == 10) {
        cout << "YES";
    } else {
        cout << "NO";
    }
    return 0;
}
